#include<LEDA/graph/graph_alg.h>
#include<LEDA/graph/graph_draw.h>
#include<LEDA/edge_array.h>
#include<LEDA/graph.h>
#include<LEDA/ugraph.h>
#include<LEDA/graph_misc.h>

using namespace leda;

int MAX_VRCHOLOV = 50;

void create_2f_graph(ugraph &G1,int poc_vrcholov,int poc_hran, int vrcholy_1, int hrany_1,int hrany_2)
/*
Vytvori dvojfarebny graf 
    vrcholy_1 -> pocet vrcholov v 1 skupine
    hrany_1 -> pocet hran v 1 skupine
    hrany_2 -> pocet hran v 2 skupine
*/
{  
//  ugraph G1;
  
  G1.make_undirected();
  
  int hrany[MAX_VRCHOLOV+1][MAX_VRCHOLOV+1];
   
  int i,i2,i3;
  
  for (i=1;i<=poc_vrcholov;i++) G1.new_node();    // vytvori presny pocet vrcholov

  for (i=1;i<=poc_vrcholov;i++) for (i2=1;i2<=poc_vrcholov;i2++) hrany[i][i2]=0;

  i=0;
  while (i<hrany_1)  // hrany v prvej skupine
  {    
    i2=1+(rand()%vrcholy_1);
    i3=1+(rand()%vrcholy_1);
    
//    printf("%d %d\n",i2,i3);
    if ((i2>=1)&&(i3>=1)&&(i2!=i3)&&(hrany[i2][i3]==0))
    {
      i++;
      hrany[i2][i3]=1;
      hrany[i3][i2]=1;
    }
  }

  i=0;
  int vrcholy_2= poc_vrcholov-vrcholy_1;
  while (i<hrany_2)  // hrany v druhej skupine
  {    
    i2=1+(rand()%vrcholy_2)+vrcholy_1;
    i3=1+(rand()%vrcholy_2)+vrcholy_1;
    
//    printf("%d %d\n",i2,i3);
    if ((i2>=1)&&(i3>=1)&&(i2!=i3)&&(hrany[i2][i3]==0))
    {
      i++;
      hrany[i2][i3]=1;
      hrany[i3][i2]=1;
    }
  }

  i=0;
  int hrany_3= poc_hran-hrany_1-hrany_2;
  while (i<hrany_3)  // hrany medzi skupinami
  {    
    i2=1+(rand()%vrcholy_1);
    i3=1+(rand()%vrcholy_2)+vrcholy_1;
    
//    printf("%d %d\n",i2,i3);
    if ((i2>=1)&&(i3>=1)&&(i2!=i3)&&(hrany[i2][i3]==0))
    {
      i++;
      hrany[i2][i3]=1;
      hrany[i3][i2]=1;
    }
  }


  node v,w;
  i=0;
  forall_nodes(v,G1) {
    i++;
    i2=0;  
    forall_nodes(w,G1) {
      i2++;
      if ((i<i2)&&(hrany[i][i2]==1)) G1.new_edge(v,w);    
    }
  }
  
//  return(G1);
  
}

